<?header("Content-Type: text/javascript");?>

/******************************

	showSource.php
	version 1.1
	last revision: 11.24.2003
	steve@slayeroffice.com

	Description:
	Opens a connection to a remote web page and does a series of regular expressions 
	to format the source of the document for viewing.

******************************/

// create a style sheet link for the pre object
// if you are hosting showSource.php yourself, you should change the style sheet href to your own server as well.
css=document.body.appendChild(document.createElement("link"));
css.id="showSourceCSS";
css.rel="stylesheet";
css.href="http://slayeroffice.com/tools/showSource/showSource.css";
css.type="text/css";

// create the PRE element needed to contain the source code
m=document.body.appendChild(document.createElement("pre"));
m.id = "mSourceWindow";
<?php
// open the document specified as "p" in the url
$p = $_GET['p'];
if($p == "") {
	$p = "http://slayeroffice.com";
	echo("alert(\"No site specified! usage:showSource.php?p=http://www.sitename.com\")\n");
}
$handle = fopen ($p, "rb");
$contents = "";

// read the contents of the file
do {
    $data = fread($handle, 8192);
    if (strlen($data) == 0) {
        break;
    }
    $contents .= $data;
} while(true);
fclose ($handle);

// replace <, >, double and single quotes with their respective entities
$contents = ereg_replace("<","&lt;",$contents);
$contents = ereg_replace(">","&gt;",$contents);
$contents = ereg_replace("'","&#39;",$contents);
// make text inside quotes bold and blue
$contents = preg_replace("/\"([^\"]*)\"/","\"<span class=mQuoted>$1</span>\"",$contents);
$contents = ereg_replace("\"","&quot;",$contents);
// create an array out of the file contents
$contents = split("\n",$contents);

$mHTML = "<a href=\"javascript:closeSourceWindow();\" title=\"close\" class=\"mBtn\">close</a><br /><br />";
for($i=0;$i<count($contents);$i++) {
	// decide the background color of each line based on the remainder of $i/2
	if($i%2 != 0) {
		$bgColor = "mCodeOn";
	} else {
		$bgColor = "mCodeOff";
	}
	// remove stray line returns
	$contents[$i] = ereg_replace(chr(13),"",$contents[$i]);
	// bold html attributes
	$contents[$i] = preg_replace("/ ([^ ]*)=&quot;/"," <b>$1=\"</b>",$contents[$i]);
	// turn html tag names purple and bold
	$contents[$i] = preg_replace("/&lt;([^ ]*) /","&lt;<span class=mHTMLTag>$1</span> ",$contents[$i]);
	$contents[$i] = preg_replace("/&lt;([^ ]*)&gt;/","&lt;<span class=mHTMLTag>$1</span>&gt;",$contents[$i]);
	// append the line to $mHTML
	$mHTML .= "<div class=" . $bgColor . "><span class=\"r\">" . ($i+1) . ":</span> " . $contents[$i] . "</div>";
}
$mHTML .= "<div class=\"mCredits\">showSource v1.1 (rev: 11.24.2003) | <a href=\"http://slayeroffice.com\" target=\"_blank\" style=\"color:#FFFFFF;text-decoration:none;\">slayeroffice.com</a> | steve@slayeroffice.com</div>";
// put the source into the PRE element
echo("m.innerHTML='" . $mHTML . "';\n");
?>

// this function is called from the "close" button - removes the PRE and LINK element from the DOM
function closeSourceWindow(){
	document.body.removeChild(document.getElementById("mSourceWindow"));
	document.body.removeChild(document.getElementById("showSourceCSS"));
}